VERSION 5.00
Begin VB.UserControl MMTimer 
   CanGetFocus     =   0   'False
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   ScaleHeight     =   3600
   ScaleWidth      =   4800
End
Attribute VB_Name = "MMTimer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Declare Function VirtualAlloc Lib "kernel32.dll" ( _
                         ByRef lpAddress As Long, _
                         ByVal dwSize As Long, _
                         ByVal flAllocationType As Long, _
                         ByVal flProtect As Long) As Long
                         
Private Declare Function VirtualFree Lib "kernel32.dll" ( _
                         ByRef lpAddress As Long, _
                         ByVal dwSize As Long, _
                         ByVal dwFreeType As Long) As Long
                         
Private Declare Function VirtualLock Lib "kernel32.dll" ( _
                         ByRef lpAddress As Any, _
                         ByVal dwSize As Long) As Long
                         
Private Const MEM_COMMIT As Long = &H1000
Private Const PAGE_EXECUTE_READWRITE As Long = &H40
Private Const MEM_RELEASE As Long = &H8000&
Private Const WM_CHAR As Long = &H102

Private Declare Sub CopyMemory Lib "kernel32.dll" _
                    Alias "RtlMoveMemory" ( _
                    ByRef Destination As Any, _
                    ByRef Source As Any, _
                    ByVal Length As Long)
                    
Private Declare Function GetProcAddress Lib "kernel32.dll" ( _
                         ByVal hModule As Long, _
                         ByVal lpProcName As String) As Long
                         
Private Declare Function GetModuleHandle Lib "kernel32.dll" _
                         Alias "GetModuleHandleA" ( _
                         ByVal lpModuleName As String) As Long
                         
Private Declare Function timeKillEvent Lib "winmm.dll" ( _
                         ByVal uID As Long) As Long
                         
Private Declare Function timeSetEvent Lib "winmm.dll" ( _
                         ByVal uDelay As Long, _
                         ByVal uResolution As Long, _
                         ByVal lpFunction As Long, _
                         ByVal dwUser As Long, _
                         ByVal uFlags As Long) As Long
                         
Private Const TIME_ONESHOT As Long = 0&
Private Const TIME_PERIODIC As Long = 1&
Private Asm As Long
Private TimerId As Long

Public Event Timer()

Public Sub StartTimer(ByVal Interval As Long, ByVal Resolution As Long, _
    ByVal OneShot As Boolean)
    
    ' sicherstellen, dass inerhalb dieser Instanz der Timer beendet ist
    StopTimer
    
    If OneShot = True Then
        TimerId = timeSetEvent(Interval, Resolution, Asm, 0, TIME_ONESHOT)
    Else
        TimerId = timeSetEvent(Interval, Resolution, Asm, 0, TIME_PERIODIC)
    End If
End Sub

Public Sub StopTimer()
    If TimerId <> 0 Then
        timeKillEvent TimerId
        TimerId = 0
    End If
End Sub

Private Sub UserControl_Initialize()
    Dim Arr(0 To 7) As Long
    Dim Tmp As Long
    
    ' push lParam
    ' push wParam
    ' push Msg
    ' push hWnd
    ' mov eax, SendMessage
    ' call eax
    ' ret 20
    Arr(0) = &H33221168
    Arr(1) = &H22116844
    Arr(2) = &H11684433
    Arr(3) = &H68443322
    Arr(4) = &H44332211
    Arr(5) = &H332211B8
    Arr(6) = &HC2D0FF44
    Arr(7) = &H14
    Tmp = 0 ' lParam setzen
    CopyMemory ByVal CLng(VarPtr(Arr(0)) + 1), Tmp, Len(Tmp)
    Tmp = 18 ' wParam setzen; 18 ist Charcode fr ein nicht darstellbares
             ' Zeichen, das nun als ID fr den Timer zweckentfremdet wird
    CopyMemory ByVal CLng(VarPtr(Arr(1)) + 2), Tmp, Len(Tmp)
    Tmp = WM_CHAR ' Message; damit wird das KeyPress-Event des angegebenen
                  ' Fensters angesprungen
    CopyMemory ByVal CLng(VarPtr(Arr(2)) + 3), Tmp, Len(Tmp)
    Tmp = UserControl.hWnd ' Fenster, an den die Timermessage geleitet wird
    CopyMemory ByVal CLng(VarPtr(Arr(4)) + 0), Tmp, Len(Tmp)
    
    ' Nachrichtenfunktion festlegen
    Tmp = GetProcAddress(GetModuleHandle("user32.dll"), "SendMessageA")
    CopyMemory ByVal CLng(VarPtr(Arr(5)) + 1), Tmp, Len(Tmp)
    
    ' verschieben in NX-kompatiblen Speicher
    Asm = VirtualAlloc(ByVal 0, 32, MEM_COMMIT, PAGE_EXECUTE_READWRITE)
    VirtualLock ByVal Asm, 32
    CopyMemory ByVal Asm, Arr(0), 32
End Sub

Private Sub UserControl_KeyPress(KeyAscii As Integer)
    If KeyAscii = 18 Then
        ' event vom timer
        RaiseEvent Timer
    End If
End Sub

Private Sub UserControl_Terminate()
    ' sicherstellen, dass Timer beendet ist und virtuellen Speicher aufrumen
    StopTimer
    VirtualFree ByVal Asm, 0, MEM_RELEASE
End Sub
